////////////////////////////////////////////////////////////////
// Autor : Regedit
// Data  : 2003-06-16
// Opis  : Szkielet aplikacji DirectX
////////////////////////////////////////////////////////////////

#pragma once

class CApplication
{
private:
	DWORD m_dwLastCzas;
	DWORD m_dwFrameCount;
	DWORD m_dwLastFrameCzas;

protected:
	bool m_bWindowed;
	bool m_bActive;
	bool m_bDeviceLost;
	bool m_bMinimized;
	bool m_bDeviceObjectsInited;
	bool m_bDeviceObjectsRestored;
	bool m_bShowCursor;
	bool m_bClosing;
	D3DPRESENT_PARAMETERS m_PresentParameters;

	HWND m_hWnd;
	LPDIRECT3D9 m_pD3D;
	LPDIRECT3DDEVICE9 m_pDevice;

	DWORD m_dwWidth;
	DWORD m_dwHeight;

	char* m_lpszClassName;
	char* m_lpszWindowName;

	DWORD m_dwFrameRate;

	void ParseParameters(char* lpszCmdLine);
	void Close() { m_bClosing = true; }

	void Initialize3DEnvironment();
	void Reset3DEnvironment();
	void Cleanup3DEnvironment();
	void Render3DEnvironment();

	// Overridable functions for the 3D scene created by the app
	virtual void ConfirmDevice(D3DCAPS9*,DWORD,D3DFORMAT)	{ }
	virtual void OneTimeSceneInit()							{ }
	virtual void InitDeviceObjects()						{ }
	virtual void RestoreDeviceObjects()						{ }
	virtual void FrameMove(DWORD dwCzas, DWORD dwDeltaCzas)	{ }
	virtual void Render()									{ }
	virtual void InvalidateDeviceObjects()					{ }
	virtual void DeleteDeviceObjects()						{ }
	virtual void FinalCleanup()								{ }

public:
    CApplication();
	virtual ~CApplication() { };
	// Zwraca true, jeli inicjalizacja si powioda. Mona wtedy uruchomi Run()
	// Zaraca false, jeli inicjalizacja si nie powioda. Trzeba wtedy nie uruchamia
	bool Create(HINSTANCE hInstance, char* lpszCmdLine);
	virtual int Run();
	virtual LRESULT MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	virtual void ParseParameter(char *lpszParameter);
	// Wywoywana po przeparsowaniu parametrw,
	// przed utworzeniem okna oraz wszelk inicjalizacj DirectX
	// Powinna zwrci:
	// true		- jeli aplikacja ma si dalej uruchamia
	// false	- jeli aplikacja nie ma si uruchomi, ale niezwocznie zakoczy
	// Moe te oczywicie wykona jakie zwizane ze swoj funkcj czynnoci
	virtual bool Confirm() { return true; }
	void Pause(bool bPause);
};