////////////////////////////////////////////////////////////////
// Autor : Regedit
// Data  : 2003-06-16
// Opis  : Klasa wyjtku do obsugi bdw
////////////////////////////////////////////////////////////////

#define ERROR_LOGSTR_DATE		"  Czas       : "
#define ERROR_LOGSTR_COMPUTER	"  Komputer   : "
#define ERROR_LOGSTR_USER		"  Uytkownik : "
#define ERROR_LOGSTR_FILE		"  Plik       : "
#define ERROR_LOGSTR_ROW		"  Wiersz     : "
#define ERROR_LOGSTR_INDEX		"  Numer      : "
#define ERROR_LOGSTR_TYPE		"  Typ        : "
#define ERROR_LOGSTR_MESSAGE	"  Komunikat  : "
#define ERROR_LOGSTR_CODE		"  Kod        : "
#define ERROR_LOGSTR_DESC		"  Opis       : "

// Typy wyjtkw
#define ERRTYPE_NORMAL 1
#define ERRTYPE_WIN32API 2
#define ERRTYPE_DIRECTX 3

// Plik loga bdw
#define ERR_LOGFILE "Errors.log"

// Znak koca wiersza do zapisywania do plikw
#define CRLF "\r\n"

// Klasa wyjtku
class CError
{
protected:
	int m_iType;
	char* m_lpszMessage;
	char* m_lpszSrcFile;
	int m_iSrcLine;
	DWORD m_dwWin32APICode;
	HRESULT m_hrDirectXCode;

	HANDLE m_hFile;

	// Funkcje do zapisywania loga o bdzie
	void Log();
	bool LogOpen();
	void LogClose();
	void LogWriteln();
	void LogWriteln(const char* lpsz);
	void LogWriteln(const char* lpsz1, const char* lpsz2);
	void LogWriteln(const char* lpsz, int i);
	void LogWriteln(const char* lpsz, DWORD dw);
	void LogWriteTime();
	void LogWriteComputerName();
	void LogWriteUserName();
	void LogWriteFileName();
	void LogWriteSourceInfo();
	void LogWriteErrorDetails();
	void LogWriteWin32APIDetails();
	void LogWriteDirectXDetails();

public:
	// Uniwersalny konstruktor
	CError(int iType, char* lpszMessage, char* lpszSrcFile, int iSrcLine, HRESULT hr = 0);

};