////////////////////////////////////////////////////////////////
// Autor : Regedit
// Data  : 2003-06-16
// Opis  : Obiekt - singleton to zarzdzania grafik
////////////////////////////////////////////////////////////////

#pragma once

#define FILE_CURSOR "Gfx\\Kursor.tga"
#define FILE_DESKTOP "Gfx\\Desktop.jpg"
#define FILE_LOGO "Gfx\\Logo.jpg"
#define FILE_BUTTONS "Gfx\\Buttons.png"

#define DESKTOPTEXTUREWIDTH 256.0f // Szeroko, do jakiej rozcignita zostanie tekstura pulpitu
#define DESKTOPTEXTUREHEIGHT 256.0f // Wysoko, do jakiej rozcignita zostanie tekstura pulpitu

extern int g_iCursorX;
extern int g_iCursorY;

class CGfx
{
protected:
	LPDIRECT3DTEXTURE9 m_texCursor;
	LPDIRECT3DTEXTURE9 m_texDesktop;
	LPDIRECT3DTEXTURE9 m_texLogo;
	LPDIRECT3DTEXTURE9 m_texButtons;

	LPD3DXFONT Font;

public:
	CGfx();
	~CGfx();

	void DrawTexture(float x1, float y1, float x2, float y2, LPDIRECT3DTEXTURE9 pTexture);

	void InitDeviceObjects();
	void RestoreDeviceObjects();
	void InvalidateDeviceObjects();
	void DeleteDeviceObjects();

	void RenderCursor();
	void RenderDesktop(float Width, float Height, float ScrollX, float ScrollY);
	void RenderLogo();

	LPDIRECT3DTEXTURE9 GetTexture_Buttons() { return m_texButtons; }
	LPD3DXFONT GetFont() { return Font; }
};

extern LPDIRECT3DDEVICE9 g_pDevice;
extern CGfx* g_pGfx;
