////////////////////////////////////////////////////////////////
// Autor : Regedit
// Data  : 2003-06-16
// Opis  : Abstrakcyjna klasa bazowa dla ekranw
////////////////////////////////////////////////////////////////
#define SCRWIDTH 800
#define SCRHEIGHT 600

#define FVF_MYVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

typedef struct
{
	D3DXVECTOR3 pos;
	float rhw;
	DWORD color;
	float tx, ty;
} MYVERTEX;

#define SCREENSTATE_NONE 0
#define SCREENSTATE_INTROEND 1
#define SCREENSTATE_MENUEND 2
#define SCREENSTATE_GAMEEND 3

typedef enum
{
	BUTTON_LEFT, BUTTON_MIDDLE, BUTTON_RIGHT
} SCREENMOUSEBUTTON;

class CScreen
{
protected:
	HWND m_hWnd;
	LPDIRECT3DDEVICE9 m_pDevice;

public:
	CScreen(HWND hWnd, LPDIRECT3DDEVICE9 pDevice) { m_hWnd = hWnd; m_pDevice = pDevice; }
	virtual ~CScreen() { }
	
	virtual void InitDeviceObjects() { }
	virtual void RestoreDeviceObjects() { }
	virtual void InvalidateDeviceObjects() { }
	virtual void DeleteDeviceObjects() { }
	virtual void Render() { }
	virtual void FrameMove(DWORD dwCzas, DWORD dwDeltaCzas) { }

	virtual void KeyDown(WPARAM wKey) { }
	virtual void KeyUp(WPARAM wKey) { }
	virtual void Char(WPARAM wKey) { }
	virtual void MouseMove(WORD x, WORD y) { }
	virtual void MouseDown(WORD x, WORD y, SCREENMOUSEBUTTON button) { }
	virtual void MouseUp(WORD x, WORD y, SCREENMOUSEBUTTON button) { }

	virtual int GetState() { return SCREENSTATE_NONE; }
	virtual DWORD GetBkgColor() { return 0xff000000; }
};