// array1d - szablon klasy - jednowymiarowa tablica elementw dowolnego typu
// Wymiary podaje si w konstruktorze i pozostaj one niezmienne
// Do elementw mona odwoywa si za pomoc operatora [] lub []
// Mona go uywa take po lewej stronie przyposania, jako l-warto
template <class T>
class array1d
{
private:
	T *m_p;
public:
	array1d(int length) { m_p = new T[length]; }
	~array1d() { delete [] m_p; }
	void set(int index, T value) { m_p[index] = value; }
	T get(int index) { return m_p[index]; }
	T & operator () (int index) { return m_p[index]; }
	T & operator [] (int index) { return m_p[index]; }
	T *GetPointer() { return m_p; }
};

// array2d - szablon klasy - dwuwymiarowa tablica elementw dowolnego typu
// Wymiary podaje si w konstruktorze i pozostaj one niezmienne
// Do elementw mona odwoywa si za pomoc dwuparametrowego operatora ()
// Mona go uywa take po lewej stronie przyposania, jako l-warto
template <class T>
class array2d
{
private:
	T *m_p;
	int m_iWidth;
public:
	array2d(int width, int height) : m_iWidth(width) { m_p = new T[width*height]; }
	~array2d() { delete [] m_p; }
	void set(int x, int y, T value) { m_p[y*m_iWidth+x] = value; }
	void set(int index, T value) { m_p[index] = value; }
	T get(int x, int y) { return m_p[y*m_iWidth+x]; }
	T get(int index) { return m_p[index]; }
	T & operator () (int x, int y) { return m_p[y*m_iWidth+x]; }
	T & operator () (int index) { return m_p[index]; }
	T & operator [] (int index) { return m_p[index]; }
	T *GetPointer() { return m_p; }
};